/*
 *	floppy to image utility v1.0 for Pyldin-601 emulator
 *	Copyright (c) Sasha Chukov, 2000
 */

#include <dos.h>
#include <bios.h>

void usage()
{
   printf("Usage:\nflop2img disk size [name]\n"
	" disk -> A:  B:\n"
	"    size -> 360, 720  1.44\n"
	"    name ->  ᪨\n"
	"ਬ:\nflop2img B: 360\n ᪠ B: ࠧ 360\n");
   exit(-1);
}

void main(int argc, char *argv[])
{
	unsigned len_written;
	int handle, MTrack, MSect, NDisk, head, track, sect;
	struct diskinfo_t di;
	unsigned short status, sega;
	char *name = "disk.img", *bukva = "K";

 printf("floppy to image utility v1.0 for Pyldin-601 emulator\n"
	"\t Copyright (c) Sasha Chukov, 2000\n\n");

	if (argc < 3) usage();

	if (strcmp(argv[1], "A:")==0) NDisk = 0;
	else if (strcmp(argv[1], "a:")==0) NDisk = 0;
	else if (strcmp(argv[1], "B:")==0) NDisk = 1;
	else if (strcmp(argv[1], "b:")==0) NDisk = 1;
	else usage();

 if(strcmp(argv[2], "360")==0){ MTrack = 39; MSect = 9;}
 else if(strcmp(argv[2], "720")==0){ MTrack = 79; MSect = 9;}
 else if(strcmp(argv[2], "1.44")==0){ MTrack = 79; MSect = 18;}
 else usage();

	if (argc == 4) name = argv[3];
	if (MSect == 18) bukva = "M";

    printf("Creating disk image %s (size %s %sb) from %s\n",
		name, argv[2], bukva, argv[1]);

	_dos_allocmem(100, &sega);
	di.buffer = MK_FP(sega, 0);

	if( _dos_creat( name, _A_NORMAL, &handle ) != 0 ) {
		printf( "Unable to create file\n" );
		exit(-1);
	}

		di.drive = NDisk;
		di.nsectors = 1;

	//᫥騥 3 ப  樠樨
	di.head = 1; di.track = 1; di.sector = 1;
	_bios_disk( _DISK_READ, &di );
	_bios_disk( _DISK_READ, &di );

    for (track = 0; track <= MTrack; track++)
      for (head = 0; head <= 1; head++)
	for (sect = 1; sect <= MSect; sect++) {
	   printf("Track=%d, Sector=%d, Head=%d  \r",
			track, sect, head);
		di.head = head;
		di.track = track;
		di.sector = sect;
	status = _bios_disk( _DISK_READ, &di );
//	printf( "Status = 0x%4.4X\n", status );
	_dos_write( handle, di.buffer, 512, &len_written );
    }
	_dos_close( handle );
	printf("Complete!                   \n");
}
