/*
 *
 * Pyldin-601 emulator version 2.1 for BeOS / Linux / Win9x/NT
 * Copyright (c) Sasha Chukov & Yura Kuznetsov, 2000-2001
 *
 */

#include <conio.h>
#include <dos.h>

#include "keyboard.h"
#include "screen.h"

char keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'1','2','3','4','5','6','7','8','9','0','-','=',0x7f,0xed,
	'q','w','e','r','t','y','u','i','o','p','[',']',0xc0,0xff,'a','s',
	'd','f','g','h','j','k','l',';',0x27,'`',0xff,'\\','z','x','c','v',
	'b','n','m',',','.','/',0xff,0xff,0xff,' ',0xfc,0xc9,0xca,0xcb,0xcc,0xcd,
	0xce,0xcf,0xd0,0xd1,0xd2,0xff,0xfb,0xc5,0xc4,0xc8,0xff,0xc1,0xff,0xc2,0xff,0xc6,
	0xc3,0xc7,0xfa,0xf9,0xff,0xff,0xff,0xd3,0xd4,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char cyr_keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'1','2','3','4','5','6','7','8','9','0','-','=',0x7f,0xed,
	'','','','','','','','','','','','',0xc0,0xff,'','',
	'','','','','','','','','','[',0xff,'\\','','','','',
	'','','','','','.',0xff,0xff,0xff,' ',0xfc,0xc9,0xca,0xcb,0xcc,0xcd,
	0xce,0xcf,0xd0,0xd1,0xd2,0xff,0xfb,0xc5,0xc4,0xc8,0xff,0xc1,0xff,0xc2,0xff,0xc6,
	0xc3,0xc7,0xfa,0xf9,0xff,0xff,0xff,0xd3,0xd4,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char Sh_keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'!','@','#','$','%','^','&','*','(',')','_','+',0x7f,0xee,
	'Q','W','E','R','T','Y','U','I','O','P','{','}',0xc0,0xff,'A','S',
	'D','F','G','H','J','K','L',':','"','~',0xff,'|','Z','X','C','V',
	'B','N','M','<','>','?',0xff,0xff,0xff,0xfd,0xfc,0xd5,0xd6,0xd7,0xd8,0xd9,
	0xda,0xdb,0xdc,0xdd,0xde,0xff,0xfb,0xc5,0xc8,0xc8,0xff,0xc5,0xff,0xc6,0xff,0xc6,
	0xc7,0xc7,0xfa,0xf9,0xff,0xff,0xff,0xdf,0xe0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char cyr_Sh_keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'!','"','#',';','%',':','?','*','(',')','_','+',0x7f,0xee,
	'','','','','','','','','','','','',0xc0,0xff,'','',
	'','','','','','','','','',']',0xff,'/','','','','',
	'','','','','',',',0xff,0xff,0xff,0xfd,0xfc,0xd5,0xd6,0xd7,0xd8,0xd9,
	0xda,0xdb,0xdc,0xdd,0xde,0xff,0xfb,0xc5,0xc8,0xc8,0xff,0xc5,0xff,0xc6,0xff,0xc6,
	0xc7,0xc7,0xfa,0xf9,0xff,0xff,0xff,0xdf,0xe0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char Ct_keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'1',0,'3','4','5',0x1e,'7','8','9','0',0x1f,'=',0xef,0xed,
	0x11,0x17,0x5,0x12,0x14,0x19,0x15,0x9,0x0f,0x10,0x1b,0x1d,0xf0,0xff,0x1,0x13,
	0x4,0x6,0x7,0x8,0xa,0xb,0xc,';',0x27,'`',0xff,0x1c,0x1a,0x18,0x3,0x16,
	0x2,0xe,0xd,',','.','/',0xff,0xff,0xff,0xfe,0xfc,0xe1,0xe2,0xe3,0xe4,0xe5,
	0xe6,0xe7,0xe8,0xe9,0xea,0xff,0xfb,0xf5,0xf4,0xf8,0xff,0xf1,0xff,0xf2,0xff,0xf6,
	0xf3,0xf7,0xfa,0xf9,0xff,0xff,0xff,0xeb,0xec,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char Ct_Sh_keytable[]={
/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f */
	0xff,0x1b,'1',0,'3','4','5',0x1e,'7','8','9','0',0x1f,'+',0xef,0xee,
	0x11,0x17,0x5,0x12,0x14,0x19,0x15,0x9,0x0f,0x10,0x1b,0x1d,0xf0,0xff,0x1,0x13,
	0x4,0x6,0x7,0x8,0xa,0xb,0xc,':','"','~',0xff,0x1c,0x1a,0x18,0x3,0x16,
	0x2,0xe,0xd,'<','>','?',0xff,0xff,0xff,0xfe,0xfc,0xe1,0xe2,0xe3,0xe4,0xe5,
	0xe6,0xe7,0xe8,0xe9,0xea,0xff,0xfb,0xf5,0xf8,0xf8,0xff,0xf5,0xff,0xf6,0xff,0xf6,
	0xf7,0xf7,0xfa,0xf9,0xff,0xff,0xff,0xeb,0xec,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

char keyReady=0,keyCode,tempKeyCode,flagKey=0,cyrMode=0;
WORD Zwait = 0;
BYTE fSound = 0;
BYTE enableCOLOR = 0xff;
BYTE enable320 = 0;
void (__interrupt __far *biosKeyboardHandler)();
// char keyboardHandlerInstalled=0;

int exitRequested = 0;
int resetRequested = 0;

BYTE led_status = 0;
BYTE visible = 0;

/*
void KbdWrite(int addr,BYTE data)
{
   BYTE status;
   do {
      status=inp(KBD_CTRL_PORT);     // Wait until input buffer empty
   } while(status & KBD_IBF);
   outp(addr,data);
}
int KbdReadData(void)
{
   int i;
   BYTE status,data;
   i=500000;
   do {
      status=inp(KBD_CTRL_PORT);
      if (!(status & KBD_OBF))      // Check if data available
	continue;
      data=inp(KBD_DATA_PORT);
      if (status & (KBD_GTO | KBD_PERR))  // Check for timeout error
	continue;
      return data;
   } while(--i);
   return -1;     // Timed out
}
void SetKeyboardLEDs(BYTE status)
{
   KbdWrite(KBD_DATA_PORT,0xED);
   if (KbdReadData()!=KBD_ACK)      // Error
	return;
   KbdWrite(KBD_DATA_PORT,status ^ KBD_LED_CAPS);
   KbdReadData();
}
 */

void __interrupt __far keyboardHandler()
{
 tempKeyCode=inp(0x60);
 keyCode=inp(0x61);        //other people have these lines in their code
 outp(0x61,keyCode|0x80);  //does anybody know why? If you do,
 outp(0x61,keyCode&0x7F);  //please send me some mail

 outp(0x20,0x20);

 keyCode=0xff;
 switch(tempKeyCode) {
	case 0: break;
	case 0x4a: if (Zwait<65535) Zwait++;	// -
		   viewInfo(); break;
	case 0x4c: fSound=~fSound; break;	// 5
	case 0x37: resetRequested=1; break;	// *

	// ctrl
	case 0x1d: flagKey|=1; break;
	case 0x9d: flagKey&=~1; break;

	// alt
	case 0x38: flagKey=8; break;
	case 0xb8: flagKey=0; break;

	// left/right shift
	case 0x2a:
	case 0x36: flagKey|=2; break;
	case 0xaa:
	case 0xb6: flagKey&=~2; break;

	default: {
		if (tempKeyCode==0x4e) {
			if (flagKey==8) Zwait=0;	// Alt +
			else if (Zwait>0) Zwait--;
			viewInfo(); break;
		}

		if (flagKey==8) {
			if (tempKeyCode==0x3b) {	// Alt-F1
				visible=~visible; viewInfo();
			}
			if (tempKeyCode==0x3c) enableCOLOR=~enableCOLOR;
			if (tempKeyCode==0x3d) enable320=~enable320;
			if (tempKeyCode==0x3e) exitRequested=1;
			break;
		}

		if (tempKeyCode<0x80){
		IRQrequest = 1;
		keyReady--;

		 switch(flagKey | cyrMode) {
		  case 1:
		  case 5: keyCode=Ct_keytable[tempKeyCode]; break;
		  case 3:
		  case 7: keyCode=Ct_Sh_keytable[tempKeyCode]; break;
		  case 2: keyCode=Sh_keytable[tempKeyCode]; break;
		  case 4: keyCode=cyr_keytable[tempKeyCode]; break;
		  case 6: keyCode=cyr_Sh_keytable[tempKeyCode]; break;
		  default: keyCode=keytable[tempKeyCode]; break;
		 }
		} else keyReady = 0;
	}
 }
}

void installKeyboardHandler(void)
{
 biosKeyboardHandler=_dos_getvect(0x09);
 _dos_setvect(0x09,keyboardHandler);
// keyboardHandlerInstalled=1;
// SetKeyboardLEDs(led_status);
}

void removeKeyboardHandler(void)
{
// if(keyboardHandlerInstalled){
_dos_setvect(0x09,biosKeyboardHandler);
// keyboardHandlerInstalled=0;
}

BYTE trigger = 0;

char checkKbd()
{
	if (keyReady) {
		trigger = ~trigger;
		if (trigger) return 0; else return 0x80;
	}
	return 0;
}

char readKbd()
{
	trigger = 0;
	if (keyReady==0) return 0xff;
	return keyCode;
}
