/*
 *    ⫠ (. dirinfo.  debug.zip).
 */

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>

#include "mc6800.h"
#include "keyboard.h"
#include "timer.h"
#include "screen.h"
#include "floppy.h"

char *romName[] = {
	"str$08.rom",
	"str$09.rom",
	"str$0a.rom",
	"str$0b.rom",
	"str$0c.rom",
	"str$0d.rom",
	"str$0e.rom",
	"str$0f.rom"
};

#ifndef INVOP_IGNORE
void putRegs(mc6800 *p)
{
	char	title[256];
	printf("A=%02x B=%02x X=%04x SP=%04x PC=%04x H=%01d I=%01d N=%01d Z=%01d V=%01d C=%01d\n%s\n",
	p->getA(), p->getB(), p->getX(), p->getSP(), p->getPC(),
	p->getH(), p->getI(), p->getN(), p->getZ(), p->getV(),
	p->getC(), p->disasm(p->getPC(), title));
}
#endif

int LoadRom(char *name, int p, mc6800 *pyl)
{
	char namp[9];
	namp[8] = 0;

	FILE *fi = fopen(name, "rb");
	if (fi) {
	  while ( fread(pyl->getRomPtr(p), 1, 8192, fi) == 8192 && p < 16) {
	    memcpy(namp, pyl->getRomPtr(p)+2, 8);
	    printf("%s -> Loaded %s rom as %d page\n", name, namp, p);
	  }
	  fclose(fi);
	}
	p++;
	return p;
}

void usage()
{
	printf(	"\nUsage:\n   pyldin.exe [/?] [-A name] [-B name] [/T] [/601A]\n"
		"      -A(-B) use disk[image] name (A: or B: for real floppy)\n"
		"      /T     set IBM date/time to Pyldin\n"
		"      /601A  for emulation model Pyldin 601A\n\n"
		"Example: pyldin.exe -A B: -B games.img\n");
	exit(0);
}

void main(int argc, char *argv[])
{
	int errc, i;
	byte *m;
	word ZwaitW,Zwait_W2;
	union REGS regs;
	char *dname0, *dname1, mas1[2], *b_name;
	FILE *fi;
	byte set_DT = 0;

	printf("Pyldin-601/601A emulator v2.0 ----- OLD version (for DEBUG)\n");

	dname0 = "A:";
	dname1 = "B:";

	i = 1;
	while (i < argc) {
		if (strcmp(argv[i], "/?") == 0) usage();
		if (strcmp(argv[i], "-A") == 0) dname0 = argv[++i];
		if (strcmp(argv[i], "-a") == 0) dname0 = argv[++i];
		if (strcmp(argv[i], "-B") == 0) dname1 = argv[++i];
		if (strcmp(argv[i], "-b") == 0) dname1 = argv[++i];
		if (strcmp(argv[i], "/601a") == 0) m601a = 0xff;
		if (strcmp(argv[i], "/601A") == 0) m601a = 0xff;
		if (strcmp(argv[i], "/t") == 0) set_DT = 0xff;
		if (strcmp(argv[i], "/T") == 0) set_DT = 0xff;
		i++;
	}

	mc6800 *pyl = new mc6800();

	// ⠥ ﭨ ⥫  㪠
	fi = fopen("wait_cnt.cpu", "rb");
	if (fi) {
		fread(mas1,1,3,fi);
		Zwait=mas1[0];
		fSound=mas1[2];
		fclose(fi);
	} else {
		Zwait=0;
		fSound=0;
	}

	// 㧨   BIOS
	if (m601a == 0) b_name="BIOS.ROM"; else b_name="BIOS_A.ROM";
	printf("Load main rom %s     ... ",b_name);
	fi = fopen(b_name, "rb");
	if (fi) {
		m = pyl->getRomPtr(-1); fread(m, 1, 4096, fi);
		fclose(fi); printf("Ok\n");
	} else { printf("\07Failed!\n"); exit(-1); }

	// 㧨 䮭 ⥪⮢ ०
	printf("Load font rom VIDEO.ROM    ... ");
	if (loadTextFont("VIDEO.ROM") == 0) printf("Ok\n");
	else { printf("\07Failed!\n"); exit(-1); }

	int j = 8;
	// ⠥ 㧨 8 襪 ࠭筮 
	for (i = 0; i < 8; i++)
		j = LoadRom(romName[i], j, pyl);

	floppyOn(); // 㡠 䫮  襣 ꫤ

	// 㧨  A:
	printf("Loading disk image A:      ... ");
	if (loadDiskImage(dname0, FLOPPY_A) == 0) printf("Ok\n");
	else printf("Failed! Use floppy A:\n");

	// 㧨  B:
	printf("Loading disk image B:      ... ");
	if (loadDiskImage(dname1, FLOPPY_B) == 0) printf("Ok\n");
	else printf("Failed! Use floppy B:\n");

	// ⮡ 뫮 㤮   
	regs.w.ax=0x0305; regs.w.bx=0;
	int386(0x16,&regs,&regs);

	printf("Press Any Key for start !\n");
	getch();

	regs.w.ax=0x12;			// 樠㥬 
	int386(0x10,&regs,&regs);
	outp(0x3ce,5); outp(0x3cf,0);
	outp(0x3ce,8); outp(0x3cf,0xff);
	viewInfo();

	_disable();
	outp(0x43, 0x36);
	outp(0x40, 0x30);
	outp(0x40, 0x56);
	_enable();


	installTimerHandler();		// ⠫ ⠩
	installKeyboardHandler();	// ⠫ 
	init765();

	if (set_DT) pyl->setDATETIME();

	pyl->reset();			//  
	do {
		if (fRef > 6) {
			if (m601a == 0) refreshScr(); else refreshScr_A();
			fRef = 0;
		}

		errc = pyl->step();	// 믮塞  

// ⥫
		ZwaitW=Zwait;
		for (;ZwaitW>0;ZwaitW--) {
			Zwait_W2=9;
			do {
				Zwait_W2--;
			} while (Zwait_W2 != 0);
		}

		if (resetRequested == 1) {
			pyl->reset();
			resetRequested = 0;
		}

	} while(errc == NOERROR && exitRequested == 0);	// 横   訡
							//  室

	removeKeyboardHandler();		// . 
	removeTimerHandler();			// . ⠩

	regs.w.ax=0x03;			// ⥪⮢ ࠭ 80x25
	int386(0x10,&regs,&regs);

	init765();

#ifndef INVOP_IGNORE
	if (errc != NOERROR) {
		putRegs(pyl);				// ᫨ 訡
		printf("error code = %d\n", errc);	//  ॣ஢
	} else
#endif
	printf("Normal shutdown");


	_disable();
	outp(0x43, 0x36);
	outp(0x40, 0x00);
	outp(0x40, 0x00);
	_enable();

	fi = fopen("wait_cnt.cpu", "wb");
	if (fi) {
		mas1[0]=Zwait;
		mas1[2]=fSound;
		fwrite(mas1,1,3,fi);
		fclose(fi);
	}

	// ࠭ ᪮ 
	unloadDiskImage(dname0, FLOPPY_A);
	unloadDiskImage(dname1, FLOPPY_B);

	floppyOff();	// 몫 䫮 ⥬

	delete pyl;
	printf(" ...\n");
}
